/*<![CDATA[*/

/**
 * Copyright (c)2010 V.Krishn (insteps.net)
 *
 * This file is part of Cookbook recipe "QNotes" for PmWiki;
 * See accompanying package for more details.
 * Package: http://insteps.net/pr/a/pmwiki/Apps/Qnotes
 *
 */

DOMAssistant.DOMReady(function(){
  if (!e) var e = window.event; //moz & win
  //wikibody
  wikibody = $$('wikibody');
  //qnotes
  qnoteRoot = $$('qnoteroot');
  qnotesSetEvents("#qnoteroot div[title]");
  //qnotesBox / ActionBar
  qnotesloading = $$('qnotesloadingcontainer');
  qnVP0 = $$('qnViewPane0');
  if(qnVP0) qnVP0Pos = Position.get(qnVP0);
  qnotesBox = $$('qnotesAction');
  qnotesBox.onclick = qnotesBoxClick;
  qnotesAB = $$('qnotesActionBar');
  if(qnotesAB) qnotesAB.addEvent("click", setQnoteActions);
  qnotesAppAction = $$('qnotesAppAction');
  if(qnotesAppAction) qnotesAppAction.addEvent("click", setQnotesAppAction);
  //qnotesList
  qnotesListLink = $$("qnotesList1-wrapper");
  if(qnotesListLink) qnotesListLink.addEvent("mousedown", qnotesListClick);
  //qnotesActionBar
  qnotesAB.style.display = 'block';
  qnotesABOPos = Position.get(qnotesAB);
  qnotesAB.style.display = 'none';
  //qnotesOpenPageForm
  qnotesOPForm = $$('qnotesOPForm');
  //qnotesEditFormBox
  qnotesEFC.style.display = 'block';
  qnotesEFOPos = Position.get(qnotesEFC);
  qnotesFrmClose.onclick = qnotesFrmCloseClick;
  qnotesFrmCloseClick();
  //qnotesEditForm
  qnotesEF = $$('qnotesEditForm');
  qnotesPostUrl = qnscripturl+'?n='+qncurpgn;
  qnotesEF.setAttribute('action', qnotesPostUrl);

  qnotesEF.setAJAXForm(qnotesHandleBeforeSave, qnotesPostResponseHandler);
  qnotesEF.onsubmit = qnotesHandleSave;
  doSet = 0; setQnoteFrmWidth(doSet);

  //Infobox
  if(typeof infoinit == 'function') infoinit();

  //Init Slidy
  if(typeof qnotes_slidy_init == 'function') {
    setTimeout(function() { qnotes_slidy_init(); }, 1000); }

});

function qnotesPostResponseHandler(rdata) {
  if (DOMAssistant.AJAX.getStatus() ==  200 &&
  DOMAssistant.AJAX.getReadyState() == 4) {
    if(rdata) {
      $(qnotesBox).innerHTML = rdata;
      msg = $(qnotesBox).elmsByAttribute('class', 'msg', 'div');
    }
    if(msg.first().innerHTML == 'Data saved...') {
      clearQnotesEditForm();
      qnshow = (qndisplaymethod == 'single') ? 1 : 0;
      setTimeout(function() { qnotesBoxClose(); qnotesFrmCloseClick(); qnotesBoxRefresh(rdata, 1, qnshow); }, 2000);
    }
  } else {
    qnotesPostErrorHandler();
  }
}
function qnotesPostErrorHandler() {
  if(msg.first().innerHTML !== 'Data saved...') {
    qnotesBox.replaceContent(
    '<div id="qnpostresponse"><div class="error">Error... <br>Please try again.</div></div>');
    setTimeout('qnotesBoxClose(); qnotesFrmCloseClick()', 2000);
  }
}
function qnotesHandleBeforeSave() {
  if( ! qnotesEF.qnotesAsync) {
    qnotesEF.addContent("<input type='hidden' name='qnotesAsync' id='qnotesAsync' value='1' />"); }
  qnotesBox.replaceContent('<div id="qnpostresponse"><div class="msg">Saving....</div></div>');
  wp = Position.get(qnotesEFC);
  ww = qnotesEFC.getStyle("height");
  Position.set($(qnotesBox), wp);
  qnotesBox.setStyle({ height: ww, width: wp.width+'px', display: 'block' });
  setTimeout('qnotesPostErrorHandler()', 12000);
}
function qnotesResponseHandler() {
  return this;
}
function qnotesHandleSave(e) {
    DOMAssistant.cancelBubble(e);
    //qnotesResponseHandler();
    return false;
}
function qnotesBoxClick(e) {
  if(e.target.id === 'closeQnoteBox') {
    DOMAssistant.cancelBubble(e);
    qnotesBoxClose();
  }
}
function qnotesFrmCloseClick() {
  Position.set($(qnotesEFC), qnotesEFOPos);
  qnotesEFC.setStyle({
    display: "none"
  });
}
function qnotesBoxClose() {
  qnotesBox.setStyle({ display: "none" });
  qnotesAB.setStyle({ display: "none" });
  return;
}
function qnotesListClick(e) {
  DOMAssistant.cancelBubble(e);
  if(e.target.tagName == 'IMG') {
    if(e.target.parentNode.tagName == 'A') {
      obj = $(e.target.parentNode);
      obj.href ='javascript:void(0)'; return false;
    } return;
  }
  if(e.target.tagName == 'A') {
    obj = $(e.target);
    if(typeof oQnLNO == 'object') { oQnLNO.removeClass('active'); }
    oQnLNO = obj; obj.addClass('active');  objEventOn = obj;
    if(obj.title == '') return;
    if( ! obj.retrieve("strUrl")) {
       obj.store("strUrl", obj.href); obj.href = '#'; }
    var strUrl = obj.retrieve("strUrl");
    t = '#qnoteroot ' + "div[title='" + obj.title + "']"
    objQnote = $(t).first();
    QnoteTitle = obj.title;
    if(qndisplaymethod == 'single') {
      var p = new Poly9.URLParser(qnotesDecodeUrl('1', strUrl));
      q = p.getQueryarray(); qncurpgn = q.n; qnpagename = q.qnp;
      qnotesEF.qnotesPage.value = qnpagename;
      if(qnoteRoot == null) { qnotesSetRootNode(); }
      if(qnfetchmode == 'async') {
        qnoteRoot.remove(); qnotesSetRootNode();
      }
      if(objQnote == null) {
        qnotesAddQnoteNode(obj, t); url = getQnotesEditUrl();
        qnotesHandleEdit(url, objQnote, qnotesHandleRefresh, 1);
      }
    }
    showQnoteWnd(e, objQnote, obj);
  }
  return false;
}
function qnotesSetLoadingImage() {
  if(qnotesloading == null) {
    qnotesLoadingImage =
        '<img border="0" id="qnotesloading" src="' + qnotesurlpath+'/lib/img/loading.gif' + '" />';
    wikibody.create("div", { id : "qnotesloadingcontainer" }, true, qnotesLoadingImage);
    qnotesloading = $$('qnotesloadingcontainer');
    qnotesloading.style.position = 'absolute';
  }
}
function qnotesSetRootNode() {
  qnotesSetLoadingImage();
  wikibody.create("div", { id : "qnoteroot", title: "/" }, true, "");
  qnoteRoot = $$('qnoteroot');
  qnoteRoot.style.display = 'none';
}
function qnotesAddQnoteNode(obj, t) {
  qnoteRoot.create("div", { title: obj.title }, true, '');
  objQnote = $(t).first();
  qnotesloading.style.display = 'block';
}
function qnotesMouseOver(e) {
  DOMAssistant.cancelBubble(e);
  obj = $(this);
  obj.addClass("hover");
}
function qnotesMouseOut(e) {
  DOMAssistant.cancelBubble(e);
  obj = $(this);
  obj.removeClass("hover");
}
function showQnoteWnd(e, objQnote, objEventOn) {
  var QnoteTitle = objQnote.title;
  qnotesBox.replaceContent('<span id="closeQnoteBox">X</span>');
  qnotesBox.addContent(objQnote.innerHTML);
  r = $(qnotesBox).elmsByAttribute("title", "/", "div");
  r.each( function(elm, idx, set) {
    if (typeof elm == 'object' && elm.title !== ''
    && elm.parentNode !== null && $(elm).hasClass("comment") == false)
      { $(elm).remove(); }
  });
  if(qnotesBox.cssSelect(":nth-child(2)").first()) {
    qnotesAddBoxTitle(QnoteTitle);
  }
  qnotesBoxToggleComment(0);
  positionQnoteWnd(objQnote, objEventOn);
  qnotesBoxPane0FixHeight();
}
function setQnoteActions(e) {
  DOMAssistant.cancelBubble(e);
  switch(e.target.innerHTML) {
    case 'New':
      handleAppQnotesNew(qnotesAB, 1);
      break;
    case 'Edit':
      url = getQnotesEditUrl();
      qnotesHandleEdit(url, objQnote, updateQnotesEditForm, 0);
      break;
    case 'Refresh':
      qnotesSetLoadingImage();
      b = Position.get(qnotesBox);
      if(qnotesloading !== null) {
        Position.set($(qnotesloading), b.left+5, b.top+14);
        qnotesloading.style.display = 'block';
      }
      url = getQnotesEditUrl();
      qnotesHandleEdit(url, objQnote, qnotesHandleRefresh, 1);
      break;
    case 'Close':
      qnotesBoxClose();
      break;
    case 'Comment':
      qnotesBoxToggleComment(2);
      break;
    case 'About Qnotes':
      qnotesAbout();
      break;
  }
  return;
}
function setQnotesAppAction(e) {
  DOMAssistant.cancelBubble(e);
  switch(e.target.innerHTML) {
    case 'New':
      handleAppQnotesNew(qnotesAppAction, 1);
    break;
    case 'Open':
      handleAppActionOpen();
    break;
    case 'Hide':
      qnotesListLink.style.display = 'none';
      e.target.innerHTML = 'Show';
    break;
    case 'Show':
      qnotesListLink.style.display = 'block';
      e.target.innerHTML = 'Hide';
    break;
    case 'About Qnotes':
      qnotesAbout();
      break;
  }
  return;
}
function qnotesAbout() {
  a = 'Copyright (c)2010 V.Krishn (insteps.net)';
  alert(
    "\nVersion: "+qnversionnum+
    "\n\nQnotes: \n \(A general purpose short-notes application build on PmWiki\)\n\n"+
    a);
}
function handleAppQnotesNew(m, n) {
    a = Position.get(m);
    if(n === 1) {
      Position.set($(qnotesEFC), a.left, a.top+a.height);
    } else {
      Position.set($(qnotesEFC), a);
    }
    qnotesBoxClose(); clearQnotesEditForm();
    qnotesEF.qnotesPage.value = qnpagename;
    qnotesEFC.style.display = 'block';
    $(qnotesEFC).setStyle({ "z-index": 101 });
    $(qnotesBox).setStyle({ "z-index": 101 });
}
function handleAppActionOpen() {
  if(qnotesOPForm) {
    a = Position.get(qnotesAppAction);
    Position.set($(qnotesOPFC), a.left, a.top+a.height);
    qnotesOPFC.style.display = 'block';
    $(qnotesOPFC).setStyle({ "z-index": 101 });
  }
}
function qnotesDecodeUrl(doDecode, url, dType) {
  if(qnpIsUTF === '0') decodeType = 1;
  if(qnpIsUTF === '1') decodeType = 0;
  if(dType) decodeType = dType;
  if(doDecode == '0') decodeType = 0;
  switch(decodeType) {
    case 0: return url;
    case 1: return unescape(url);
    case 2: return decodeURI(url);
    case 3: return decodeURIComponent(url);
    default: return url;
  }
  return;
}
function getQnotesEditUrl(doEncode, url) {
  if(qnpIsUTF === '0') encodeType = 2;
  if(qnpIsUTF === '1') encodeType = 0;
  url = url ? url : qnscripturl+'?n='+qncurpgn+'&qn='+QnoteTitle+'&qnp='+qnpagename;
  if(doEncode == '0') encodeType = 0;
  switch(encodeType) {
    case 0: return url;
    case 1: return escape(url);
    case 2: return encodeURI(url);
    case 3: return encodeURIComponent(url);
    default: return url;
  }
  return;
}
function qnotesHandleEdit(url, objQnote, callback, isHtml) {
  if(isHtml) { url = url + '&async=1&html=1&action=editQNotes'; }
    else {  url = url + '&async=1'; }
  $(objQnote).ajax({
    url : url,
    method : "GET",
    params : "name=qnotesGet",
    callback : callback,
    headers : {
      "Content-type" : "text/plain"
    },
    responseType : "text",
    timeout : 5000,
    exception : function(e) {
      alert("Ajax error: " + (e.message || e.description));
    }
  });
  return;
}
function qnotesBoxToggleComment(isShow) {
  rcd = qnotesBox.elmsByAttribute("class", "comment", "div");
  if(isShow == 2) {
    rcd.each( function(elm, idx, set) {
      d = $(elm).getStyle("display");
      if (d == 'none' || d == '') { elm.setStyle({ display: "block" }); return; }
      if (d == 'block') { elm.setStyle({ display: "none" }); return; }
    });
  }
  if(isShow == 0) { $(rcd).setStyle({ display: "none" }); return; }
  if(isShow == 1) { $(rcd).setStyle({ display: "block" }); return; }
}
function qnotesBoxRefresh(rdata, isNodeRefesh, isBoxReShow) {
  $(qnotesBox).replaceContent(rdata);
  r = $(qnotesBox).elmsByAttribute("title", '', "div");
  r1 = $(r).first().elmsByAttribute("class", 'refreshdata', "div");
  qnotesBox.replaceContent('<span id="closeQnoteBox">X</span>');
  $(qnotesBox).addContent(r1.first().innerHTML);

  qnotesAddBoxTitle(r.first().title);
  qnotesBoxToggleComment(0);
  rdata = r1.first().innerHTML;
  t = r.first().title;
  qnotesBoxPane0FixHeight();
  if(isNodeRefesh === 1) qnotesNodeRefresh(rdata, t);
  if(isBoxReShow === 1 && typeof(objQnote) != 'undefined') {
    setTimeout(function() { positionQnoteWnd(objQnote, objEventOn); }, 100);}
}
function qnotesAddBoxTitle(title) {
  c1 = qnotesBox.cssSelect(":nth-child(2)");
  c2 = qnotesBox.cssSelect(":nth-child(3)");
  if( ! c1.first()) { return; }
  c1.first().title = c1.first().innerHTML;
  c1.first().addClass('fheading');
  c2.first().title = title;
}
function qnotesBoxPane0FixHeight() {
  if(qnVP0) {
    r = qnotesBox.cssSelect("> div[class=text]").first();
    if(r) { r.setStyle("height", qnVP0Pos.height-qnotesABOPos.height-5+"px"); }
  }
}
function qnotesNodeRefresh(rdata, t) {
  o = '#qnoteroot ' + "div[title='" + t + "']"; o1 = $(o);
  if(o1.length == 0) { window.location = qnotesPostUrl; return; }
  obj = o1.first();
  r = '#qnoteroot ' + "div[title='" + obj.title + "']" + " > h3";
  r1 = '#qnoteroot ' + "div[title='" + obj.title + "']" + " > div";
  if($(r).first()) $(r).first().remove();
  if($(r1).first() && $(r1).first().title == '') $(r1).first().remove();
  obj.replaceContent(rdata+obj.innerHTML);
  qnotesSetEvents("#qnoteroot div[title]");
}
function qnotesHandleRefresh(rdata) {
  if (DOMAssistant.AJAX.getStatus() ==  200 &&
      DOMAssistant.AJAX.getReadyState() == 4)
  {
    if(qnotesloading !== null) qnotesloading.style.display = 'none';
    qnotesBoxRefresh(rdata, 1, 0);
  }
  return;
}
function updateQnotesEditForm(rdata) {
  a = Position.get(qnotesBox);
  qnotesBoxClose(); clearQnotesEditForm();
  if (DOMAssistant.AJAX.getStatus() ==  200 &&
      DOMAssistant.AJAX.getReadyState() == 4) {
    $(qnotesBox).innerHTML = rdata;
    r = $(qnotesBox).elmsByAttribute('title', '', 'div');
    r1 = $(r).first().elmsByAttribute('class', "", 'div');
    qnotesEF.qnotesCategory.value = r1[0].innerHTML;
    qnotesEF.qnotesTitle.value = r1[1].innerHTML;
    if(/Konqueror|KHTML/.test(navigator.userAgent)) {
      qnotesEF.qnotesText.innerHTML = r1[2].innerHTML;
    } else { qnotesEF.qnotesText.value = r1[2].innerHTML; }
    if(r1.length > 3) {
      qnotesIsLink.checked = true; toggleQNotesLinkFrm();
      qnotesEF.qnotesLinkToPgName.value = r1[3].innerHTML;
      qnotesEF.qnotesLinkTo.value = r1[4].innerHTML;
      if(/Konqueror|KHTML/.test(navigator.userAgent)) {
        qnotesEF.qnotesComment.innerHTML = r1[5].innerHTML;
        qnotesEF.qnotesText.innerHTML = 'linked-note';
      } else {
        qnotesEF.qnotesComment.value = r1[5].innerHTML;
        qnotesEF.qnotesText.value = 'linked-note';
      }
    } else {
      qnotesIsLink.checked = false; toggleQNotesLinkFrm();
    }
    Position.set($(qnotesEFC), a);
    qnotesEFC.style.display = 'block';
  }
  return;
}
function clearQnotesEditForm() {
  qnotesEF.qnotesCategory.value = '/default';
  qnotesEF.qnotesTitle.value = '#';
  qnotesEF.qnotesLinkToPgName.value = '';
  qnotesEF.qnotesLinkTo.value = '';
  if(/Konqueror|KHTML/.test(navigator.userAgent)) {
    qnotesEF.qnotesText.innerHTML = '';
    qnotesEF.qnotesComment.innerHTML = '';
  } else {
    qnotesEF.qnotesText.value = '';
    qnotesEF.qnotesComment.value = '';
  }
  return;
}
function setQnoteViewPane0(objQnote, objEventOn) {
  a = Position.get(objQnote); b = Position.get(objEventOn);
  w = Position.get(wikibody); vp1 = Position.get(qnVP0);
  if(qnVP0.style.display == 'none') {
    if(qnotesloading !== null) { qnotesloading.setStyle({ "display": 'none'}); }
    return;
  }
  if(qnotesloading !== null) {
    Position.set(qnotesloading, vp1.left+5, vp1.top+2);
    qnotesloading.setStyle({ "z-index": 102 });
  }
  if(typeof(qnmask1) == 'undefined') {
    qnmask1 = '<div id="qnmask1" style="background-color:transparent;">&nbsp;</div>';
    wikibody.addContent(qnmask1); qnmask1 = $$('qnmask1');
    qnmask1.setStyle({ position: 'absolute', display: 'none' });
  }
  Position.set(qnmask1, b); maxwidth = vp1.width;
  qnmask1.setStyle({ width: b.width+'px', display: 'block' });

  qnVP0.setStyle({ "z-index": 100 });
  qnotesEFC.setStyle({ "z-index": 101 });
  qnotesBox.setStyle({ "z-index": 101 });

  Position.set(qnotesBox, vp1.left+1, vp1.top+1);
  abh = qnotesABOPos.height;
  Position.set($(qnotesAB), vp1.left, vp1.top-abh);
  qnotesAB.setStyle({ display: "block", position: "absolute", width: maxwidth+'px' });
  qnotesBox.setStyle({ display: "block", height: vp1.height-6+'px', width: maxwidth-3+'px' });
  setTimeout('qnmask(0, 1)', 2000);
  return;
}
function qnmask(m, n) {
 if(m == 0) $$('qnmask'+n).setStyle({ display: 'none' });
}
function positionQnoteWnd(objQnote, objEventOn) {
  a = Position.get(objQnote); b = Position.get(objEventOn); w = Position.get(wikibody);
  if(qnVP0) {
    setQnoteViewPane0(objQnote, objEventOn);
  } else {
    vp1 = b; maxwidth = (w.width - vp1.left) + w.left - 19;
    if(qnotesloading !== null) Position.set($(qnotesloading), vp1.left+5, vp1.top+2);
    Position.set(qnotesBox, vp1);
    abh = qnotesABOPos.height;
    Position.set($(qnotesAB), vp1.left, vp1.top-abh);
    qnotesAB.setStyle({ display: "block", position: "absolute", width: maxwidth+'px' });
    qnotesBox.setStyle({ display: "block", height: "auto", width: maxwidth+'px' });
    setTimeout('', 100); b = Position.get(objEventOn); w = Position.get(wikibody);
    maxwidth = (w.width - b.left) + w.left - 12; qnotesBox.setStyle({ width: maxwidth+'px' });
  }
  if(typeof maxwidth != 'undefined' && maxwidth > 410) { doSet = 1; } else { doSet = 0; }
  setQnoteFrmWidth(doSet);
}
function setQnoteFrmWidth(doSet) {
  a = '147px'; b = '142px'; c = '142px';
  if(doSet === 1) { a = '403px'; b = '275px'; c = '400px'; }
  qnotesEFC.style.width = a;
  r = $(qnotesEF).elmsByAttribute('type', 'text', 'input');
  r.each( function(elm, idx, set) { $(elm).style.width = b; });
}
function qnotesSetEvents(r) {
  //$(r).removeEvent("mouseover", qnotesMouseOver);
  //$(r).removeEvent("mouseout", qnotesMouseOut);
  $(r).removeEvent("mouseup", showQnoteActions);
  //$(r).addEvent("mouseover", qnotesMouseOver);
  //$(r).addEvent("mouseout", qnotesMouseOut);
  $(r).addEvent("mouseup", showQnoteActions);
}
function showQnoteActions(e) {
  DOMAssistant.cancelBubble(e);
  objQnote = $(this);
  if(objQnote.hasClass("comment") == true) return;
  QnoteTitle = objQnote.title;
  showQnoteWnd(e, objQnote, objQnote);
  return;
}



/*]]>*/

