/*<![CDATA[*/

/**
 * Copyright (c)2010 V.Krishn (insteps.net)
 *
 * This file is part of Cookbook recipe "QNotes" for PmWiki;
 * See accompanying package for more details.
 * Package: http://insteps.net/pr/a/pmwiki/Apps/Qnotes
 *
 * Slidy behaviour for QNotes.
 * Description: A simple slide-show / notes-navigator module.
 *
 */

qnotes_slidy = {};
qnotes_slidy.delay = 5000;

function qnotes_slidy_init() {

  if(qnotesListLink) { qnotesListLink.addEvent("mousedown", qnotesListClickSlidy); }
  qnotes_slidy.llinks = $(qnotesListLink).elmsByAttribute('class', 'phplm', 'a');
  qnotes_slidy.llinks.each( function(elm, idx, set) {
    $(elm).store("cnum", idx);
  });
  qnotes_slidy_init_btn();
  var countdown;

}
function qnotes_slidy_init_btn() {
  qnotesSlidy = $$("qnotes_slidy");
  qnotes_slidy.btns = $(qnotesSlidy).elmsByAttribute('', '', 'a');
  qnotes_slidy.btn0 = qnotes_slidy.btns[0];
  if(qnotes_slidy.btn0) { $(qnotes_slidy.btn0).addEvent("click", function() { qnotes_slidy_first(); }); }
  qnotes_slidy.btn1 = qnotes_slidy.btns[1];
  if(qnotes_slidy.btn1) { $(qnotes_slidy.btn1).addEvent("click", function() { qnotes_slidy_prev(); }); }
  qnotes_slidy.btn2 = qnotes_slidy.btns[2];
  if(qnotes_slidy.btn2) { $(qnotes_slidy.btn2).addEvent("click", function() { qnotes_slidy_start(); }); }
  qnotes_slidy.btn3 = qnotes_slidy.btns[3];
  if(qnotes_slidy.btn3) { $(qnotes_slidy.btn3).addEvent("click", function() { qnotes_slidy_stop(); }); }
  qnotes_slidy.btn4 = qnotes_slidy.btns[4];
  if(qnotes_slidy.btn4) { $(qnotes_slidy.btn4).addEvent("click", function() { qnotes_slidy_next(); }); }
  qnotes_slidy.btn5 = qnotes_slidy.btns[5];
  if(qnotes_slidy.btn5) { $(qnotes_slidy.btn5).addEvent("click", function() { qnotes_slidy_last(); }); }
}
function qnotesListClickSlidy(e) {
  cnum = $(e.target).retrieve("cnum");
  qnotes_slidy.cnum = cnum;
}
function qnotes_slidy_first() {
  qnotes_slidy_trigger(qnotes_slidy, 0);
  qnotes_slidy_clear();
}
function qnotes_slidy_prev() {
  n = 0; if(typeof qnotes_slidy.cnum == 'number') { n = qnotes_slidy.cnum-1; }
  qnotes_slidy_trigger(qnotes_slidy, n);
  qnotes_slidy_clear();
}
function qnotes_slidy_start() {
  if($(qnotes_slidy.btn2).innerHTML == 'Pause') {
    qnotes_slidy_clear(); return;
  } else {
    $(qnotes_slidy.btn2).innerHTML = 'Pause';
  }
  n = 0; if(typeof qnotes_slidy.cnum == 'number') { n = qnotes_slidy.cnum; }
  qnotes_slidy_trigger(qnotes_slidy, n);
}
function qnotes_slidy_stop() {
  qnotes_slidy_clear();
  qnotes_slidy_first();
  qnotes_slidy.cnum = 0;
  qnotesBoxClose();
}
function qnotes_slidy_next() {
  n = 0;  if(typeof qnotes_slidy.cnum == 'number') { n = qnotes_slidy.cnum+1; }
  qnotes_slidy_trigger(qnotes_slidy, n);
  qnotes_slidy_clear();
}
function qnotes_slidy_last() {
  qnotes_slidy_trigger(qnotes_slidy, qnotes_slidy.llinks.length-1);
  qnotes_slidy_clear();
}
function qnotes_slidy_trigger(slidy, cnum) {
  len = slidy.llinks.length;
  if(cnum <= len) {
    o = slidy.llinks[cnum];
    if(typeof o !== 'undefined') { o = $(o); } else { return; }
    slidy.cnum = cnum; cnum++;
    o.triggerEvent("mousedown");
    if(cnum < len) {
      countdown = setTimeout(function() { qnotes_slidy_trigger(slidy, cnum); }, qnotes_slidy.delay);
    }
  }
}
function qnotes_slidy_clear() {
  $(qnotes_slidy.btn2).innerHTML = 'Start';
  if(typeof(countdown) != 'undefined') { clearTimeout(countdown); }
}


/*]]>*/

