<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.php
 * @author V.Krishn (vkrishn@insteps.net)
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 *
 * @category pmwiki/cookbook
 * @package qnotes
 * @copyright Copyright (c) 2010 V.Krishn (vkrishn@insteps.net)
 * @license GPL
 * @version 2.2.3
 */

global $QNotes;
if ( ! IsEnabled($EnableQNotes, 0)) return;

## Current script variables
    if ( ! defined('DS') ) { define('DS', DIRECTORY_SEPARATOR); }
    $QNotes['Current']['dir'] = dirname(__FILE__);
    $EnableQNotesDebug = 0; # 0=no debug, 1=debug messages, 2=all
    $QNotes['debug']['msg'] = array();

## Get cookbook/modules meta and version variables
## @todo xml version of the metapage
    if (file_exists($QNotes['Current']['dir'] . DS . "version.php")) {
      include_once($QNotes['Current']['dir'] . DS . "version.php");
    }

## Get wiki group and pagename for use
    $QNotes['page']['CurrentGroup'] = FmtPageName('$Group', $pagename);
    $QNotes['page']['CurrentName'] = FmtPageName('$Name', $pagename);

## Set modules/cookbook install variables.
## Change these values accordingly.
    SDV($QNotes['Install']['location'], '0'); # 0=field, 1=farm, 2=others
    SDV($QNotes['Install']['path'], 'cookbook'); # relative to field or farm
    SDV($QNotes['Install']['dir'], 'qnotes'); # folder where installed
    SDV($QNotes['Install']['icon']['dir'], 'icons'); # icons to be used in qnotes

## Set default values of GROUP and PAGE for QNotes
    SDV($QNotes['default']['QNotesGroup'], 'QNotes');
    SDV($QNotes['default']['QNotesPageName'], 'QNotes1');

## Set page for qnotes application data
    SDV($QNotes['AppDataSetting'], $QNotes['default']['QNotesGroup'].'.AppDataSetting');

## Set default page to open for QNotes
    SDV($QNotes['DefaultPage'], $QNotes['default']['QNotesGroup'].'.'.$QNotes['default']['QNotesPageName']);

## To allow editing /w pass
    SDV($QNotes['qnotesIsAuthEdit'], true);
## To allow link resolving on page load
    SDV($QNotes['isResolveLinkOnPageLoad'], true);
## To post new node at end
    # defaults - only new root node is posted at end
    #          - new child nodes are posted at beginning (forum style)
    # allowed values - 1,3 (others @todo)
    #  1 - only new root node is posted at end
    #  3 - new root and child nodes are posted at end (section edit style)
    SDV($QNotes['isNewPostAtEnd'], 1);

## Allow directives in texts
    SDV($QNotes['isAllowDirectivesInText'], 0); # 0|1 - no|allow

## Error messages
    SDV($QNotes['qnotesPageNotFound'], '[--%red%link: page not found...%%--]');
    SDV($QNotes['qnotesNoteNotFound'], '[--%red%link: qnote not found...%%--]');
    SDV($QNotes['qnotesSelfLink'], '[--%red%link: selflink...%%--]');
    SDV($QNotes['qnotesRecursiveLink'], '%blue%link...%%');
    SDV($QNotes['qnotesLinkNoResolveOnPageLoad'], '%green%link...%%');
    SDV($QNotes['qnotesOPN_Msg'], 'Page Not Found...');


    // --------------------------------------
    // Would not require to edit below this
    // --------------------------------------



// //////////////////////////////////////////////////////////
//
// (:qnotes uniqueID qnoteDrawType qnotePage options :)
//    id - unique id
//    qnoteDrawType - list | editform | qnotes | link
//    qnotePage - qnotes page (default - <qnoteDefaultGroup>/<qnoteDefaultPage> )
//    options - options for list/editform/qnotes (see manual)
//
// //////////////////////////////////////////////////////////
if ($action == 'edit') { return; } # improves full page edit performance, but preview would not be available
Markup('qnotes','directives','/\\(:qnotes\\s(.*?):\\)/e',"qnotes('$1')");
$QNotes['qnotesDisplayMethod'] = PageTextVar($pagename,'qnotesDisplayMethod');
$QNotes['qnotesBehaviour'] = PageTextVar($pagename,'qnotesBehaviour');
$t = $QNotes['AppDataSetting'];
$FmtPV['$qnotesappsetting'] = "'$t'";
$HandleActions['editQNotes'] = 'qnotesEdit';
$HandleAuth['editQNotes'] = 'edit'; //@todo
$FmtPV['$qnoteCategory'] = "'/default'";
$FmtPV['$qnoteTitle'] = "'#'";
$FmtPV['$qnoteText'] = "''";
SDVA($QNotes['formDataElement'], array(
     'qnotesCategory','qnotesTitle','qnotesText',
     'qnotesLinkToPgName','qnotesLinkTo','qnotesComment',
     'qnotesPage'));
$HandleActions['qnoteupgrade'] = 'qnotesUpgrade';
$QNotes['now'] = getdate(time());

if(strtolower($QNotes['qnotesBehaviour']) == 'sectionedit') {
 $QNotes['isNewPostAtEnd'] = isset($QNotes['isSectionEditNewPostAtEnd']) ?
       $QNotes['isSectionEditNewPostAtEnd'] : 3;
}

//Handle open qnotes page
if(strtolower(@$QNotes['qnotesDisplayMethod']) == 'single') {
  include_once('scripts/qnotes.pageopen.php');
}

//Handle edit text request
if($_GET['qn'] && $_GET['qnp'] && $_POST['qnotesSubmit'] !== 'Save') { //@todo
  include_once('scripts/qnotes.edit.php');
}

//Handle upgrades
function qnotesUpgrade() {
  global $QNotes, $cookbook;
  if($_GET['qnupgrade'] == '1' && $_GET['qnupgradeto'] && $_POST['qnotesSubmit'] !== 'Save') {
    if (file_exists($QNotes['Current']['dir'] . DS . 'scripts/upgrade/qnotes.upgrade.php')) {
      include_once("scripts/upgrade/qnotes.upgrade.php");
    }
  }
  exit(0);
}

//Handle form posting
function qnotesEdit() {
  global $QNotes, $Charset,
  $HTMLHeaderFmt, $HTMLFooterFmt,
  $EnableQNotesDebug;

  include_once('scripts/functions.php');
  include_once('scripts/get_set_qnotes.php');
  include_once('scripts/set_path_file.php');

  // updated node data (refresh request)
  if($_GET['async'] && $_GET['async'] == '1' && $_GET['html'] == '1') {
    include_once('scripts/qnotes.nodedata.php');
  }

  #reserved id for form posting #todo
  if(isset($_POST['qnotesFrmId']) && isset($_POST['qnotesSubmit'])) {
    include_once('scripts/qnotes.post.php');
  }

  return;
}

function qnotes($params) {
  global $QNotes, $ScriptUrl,
         $HTMLHeaderFmt, $HTMLFooterFmt,
         $EnableQNotesDebug;

  static $qnotesCount; $qnotesCount++;
  include_once('scripts/functions.php');
  include_once('scripts/get_set_qnotes.php');
  include_once('scripts/set_path_file.php');

  qnotes_init_lib();

  //shortname
  $qnotesInstallDir = &$QNotes['Current']['dir'];
  $qnotesInstallUrl = &$QNotes['Install']['dirUrl'];
  $qnotesInstallUrlPath = &$QNotes['Install']['dirUrlPath'];
  $qnotesIconDir = &$QNotes['Install']['icon']['dirFmt'];
  $qnotesIconUrl = &$QNotes['Install']['icon']['dirUrl'];
  $qnotesIconUrlPath = &$QNotes['Install']['icon']['dirUrlPath'];
  include_once('themes/themes.php');

  $args = ParseArgs($params);
  $count = count($args[""]);
  if($EnableQNotesDebug > 0) {
    $QNotes['args'][] = $args;
  }

  switch (strtolower(@$args[''][1])) {
    case 'qnotes':
      include_once('scripts/qnotes.notes.php');
      break;
    case 'list':
      include_once('scripts/qnotes.list.php');
      break;
    case 'editform':
      include_once('scripts/qnotes.editform.php');
      break;
    case 'link':
      include('scripts/qnotes.link.php');
      break;
  }

  ## Debug
  $qnotesDebugMsg = QNotesDebug($EnableQNotesDebug);
  if($qnotesDebugMsg) {
    @$HTMLFooterFmt['qnotes_DEBUG'] =
        '<pre>' . $qnotesDebugMsg . '</pre>' . "\n";
  }

  return @$qnotesOutFmt;
  //return '<pre>' . print_r($a,true) . print_r($b,true) . '</pre>';

}




