<?php if (!defined('PmWiki')) exit();
/**
 * functions.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Some fuctions
// **********************************************************
  function qnotes_get_page($pagename) {
    if (PageExists($pagename)) {
      $page = RetrieveAuthPage($pagename,'read');
      return $page;
    }
    return false;
  }
  function qnotes_get_page_content($pagename, $pagesection='') {
    if (PageExists($pagename)) {
      if($pagesection) {
        $page['text'] = RetrieveAuthSection($pagename, $pagesection);
        } else { $page = qnotes_get_page($pagename); }
      if(isset($page['text'])) return $page['text'];
    }
    return false;
  }

  function qnotes_isvalid_qnotespage() {
  }

  function qnotes_make_css_header_link($href) {
    if (!$href) return;
      else { return "<link rel='stylesheet' href='$href' type='text/css' />"; }
  }

  function qnotes_make_script_header_link($src) {
    if (!$src) return;
      else { return "<script type='text/javascript' src='$src'></script>"; }
  }

  //Get and send updated node data.
  function qnotesGetRefreshData($qn, $qnp) {
    $qnpage = qnotes_get_page($qnp);
    $cn = qnotes_node_get_bycategory($qnp, $qn, $qnpage);
    $nt['text'] = &$cn[0];
    $a = qnotes_nodetext_get_bycategory($qnp, $qn, $nt, 0);
    $a = MarkupToHTML($qnp, $a);
    qnotesSetAsyncDataHeader();
    return $a;
  }

  function qnotesSetAsyncRequestUrl($isDecode=1) { //@todo
    if( ! $isDecode) return;
    $userAgent = getenv('HTTP_USER_AGENT');
    if(preg_match('/opera/i', $userAgent, $m)) $browser = 'opera'; //@todo
    if(preg_match('/mozilla/i', $userAgent, $m)) $browser = 'mozilla';
    if(@$_GET['async'] === '1') {
      switch ($browser) {
        case 'opera':
          $_GET['qn'] = utf8_decode($_GET['qn']); $_GET['qnp'] = utf8_decode($_GET['qnp']);
          break;
        case 'mozilla':
          $_GET['qn'] = utf8_decode($_GET['qn']); $_GET['qnp'] = utf8_decode($_GET['qnp']);
          break;
        default:
          $_GET['qn'] = $_GET['qn']; $_GET['qnp'] = $_GET['qnp'];
          break;
      }
    }
  }

  function qnotesSetAsyncDataHeader() { //@todo
    //header('Content-type: text/plain');
    $headers[] = 'Content-type: text/html;';
    global $HTTPHeaders; $h = strtolower(implode("; ", $HTTPHeaders));
    global $Charset;
    if(isset($Charset) && $Charset == 'UTF-8') {
      $headers[] = 'charset=UTF-8;'; //@todo
    } else {
      if(preg_match('/iso-8859-1/i', $h, $m)) $headers[] = 'charset=ISO-8859-1;';
      if(preg_match('/iso-8859-2/i', $h, $m)) $headers[] = 'charset=ISO-8859-2;';
      if(preg_match('/iso-8859-9/i', $h, $m)) $headers[] = 'charset=ISO-8859-9;';
      if(preg_match('/iso-8859-13/i', $h, $m)) $headers[] = 'charset=ISO-8859-13;';
    }
    $h = implode(" ", $headers);
    header($h);
  }

  /* AJAX check, not all servers provide these variables  */
  function qnotesIsAjaxRequest() {
    $isXmlHttpRequest =
        array_key_exists('X_REQUESTED_WITH', $_SERVER) &&
        strtolower($_SERVER['X_REQUESTED_WITH']) == 'xmlhttprequest';
    $isAjax =
        array_key_exists('HTTP_AJAX', $_SERVER) &&
        $_SERVER['HTTP_AJAX'] == 'true';
    if ($isXmlHttpRequest || $isAjax) { return true; }
    return false;
  }

## Initiate lib
  function qnotes_init_lib($params=array()) {
    static $init_count;
    if($init_count < 1) {
    }
    $init_count++;
    return;
  }



// ****************************************



// **********************************************************


/**
 * Set/Show debug.
 * @param int value for debug level
 */
// *******************************************************
  function QNotesDebug($EnableQNotesDebug=0) {
    global $QNotes;
    if(1 === $EnableQNotesDebug) {
      $qnotesDebugMsg = print_r($QNotes['debug']['msg'], true);
    }
    if(2 === $EnableQNotesDebug) {
      $qnotesDebugMsg = print_r($QNotes, true);
    }
    return $qnotesDebugMsg;
  }
// *******************************************************


