<?php if (!defined('PmWiki')) exit();
/**
 * qnote-upgrade-from-2.2.0-to-2.2.2.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Handle upgrade from 2.2.0 to 2.2.2
// **********************************************************
/*
  Upgrade url example
  http://example.com/pmwiki/pmwiki.php?n=QNotes.PageName&qnupgrade=1&qnupgradeto=2.2.2&action=qnoteupgrade
*/

    $qnUpgradeVersion = '4b196d41e5a6337e194953c49914ae88';
    $qnHandleUpgrades = array('2.2.2', '2.2.2-beta-3', '2.2.2-beta-4');
    $qnupgradeto = $_GET['qnupgradeto'];
    $qnVersion = $QNotes['version'];
    $qnVersionNum = $QNotes['versionnum'];
    static $d = 0;

    if( $qnVersionNum >= 2002002 &&
        in_array($qnVersion, $qnHandleUpgrades) &&
        in_array($qnupgradeto, $qnHandleUpgrades)
      ) { $qnoteDoUpgrade = 1; } else { $qnoteDoUpgrade = 0; }

    if($QNotes['qnotesIsAuthEdit']) {
      $page = RetrieveAuthPage($qnpagename, 'edit', 1);
    } else { $page = RetrieveAuthPage($qnpagename, 'read', 0); }
    if ( ! $page) return;
    $pagefmt = @$page['text'];

    print "<pre>\n";
    print_r("Upgrading Qnotes Version: \n");
    print_r("  To: ".$GLOBALS["qnotesVersion"]);
    print "\n======================================\n";


    //Stage Version Check
    // ----------------------------------------
    if( ! $qnoteDoUpgrade ) {
      print_r("Upgrade Failed: Version mismatch...\n");
      exit(0);
    }
    // ----------------------------------------

    //Stage - Check if already upgraded
    // ----------------------------------------
    preg_match("/$qnUpgradeVersion/i", $pagefmt, $m);
    if(trim($m[0])) {
      print_r("Upgrade aborted: Page already upgraded...\n");
      exit(0);
    }
    // ----------------------------------------

    //Stage - Check if Qnote root node exists
    // ----------------------------------------
    preg_match("/\\(:div title='\\/' id='qnoteroot'/i", $pagefmt, $m);
    if( ! trim($m[0])) {
      print_r("Upgrade aborted: Does not seem like Qnotes page...\n");
      exit(0);
    }
    // ----------------------------------------


    //Stage 1
    // ----------------------------------------
    $p = array();
    $p[0] = '/\\(:div100/i';
    $p[1] = '/\\(:div id=\'categories\'/i';
    $p[2] = '/\\(:div id=qnotesAction/i';
    $rep = array();
    $rep[0] = "(:div490";
    $rep[1] = "(:div510 id='categories'";
    $rep[2] = "(:div520 id=qnotesAction";
    $pagefmt = preg_replace($p, $rep, $pagefmt);

    if($pagefmt) {
      print_r("Stage 1: OK... \n");
    }

    //Stage 2
    // ----------------------------------------
    function qnotes_nodes_upgrade($matches) {
      $num = $matches[1]+300;
      return '(:div' . $num . ' ' .$matches[2];
    }
    $p2 = '/\\(:div(\d{1,2})\\s(title=\'.*?:\\))/i';
    $pagefmt = preg_replace_callback($p2, 'qnotes_nodes_upgrade', $pagefmt);

    if($pagefmt) {
      print_r("Stage 2: OK... \n");
    }

    function qnotes_nodes_upgrade21($matches) {
      $num = $matches[1]+300;
      return '(:div' . $num . $matches[2];
    }
    $p21 = '/\\(:div(\d{1,2})(end:\\))/i';
    $pagefmt = preg_replace_callback($p21, 'qnotes_nodes_upgrade21', $pagefmt);

    if($pagefmt) {
      print_r("Stage 21: OK... \n");
    }
    // ----------------------------------------

    //Stage 3
    // ----------------------------------------
    $p3[] = '/\\(:div title=\'\/\'/i';
    $p3[] = '/\\(:div520(.*?)(\\(:divend:\\))/is';
    $p3[] = '/\\(:div510(.*?)(\\(:divend:\\))/is';
    $p3[] = '/\\(:divend:\\)(.*?[[#qnotesend]])/is';

    $rep3[] = "(:div300 title='/'";
    $rep3[] = "(:div520".'$1'.'(:div520end:)';
    $rep3[] = "(:div510".'$1'.'(:div510end:)';
    $rep3[] = "(:div300end:)".'$1';

    $pagefmt = preg_replace($p3, $rep3, $pagefmt);

    $pagefmt = $pagefmt ."\n" .
        '(:comment Do not delete qnoteVersion:'.$QNotes['version'].' '.$qnUpgradeVersion .':)' . "\n";

    if($pagefmt) {
      print_r("Stage 3: OK... \n");
    }
    // ----------------------------------------

    //Stage 4
    // Write on page
    // ----------------------------------------
    if($pagefmt) {
      print_r("Stage 4: (Writting Back Page... - " . ") OK... \n");
    }
    $new = $page;
    $new['text'] = $pagefmt;
    if ($d < 1) {
      $d++;
      $IsPagePosted = UpdatePage($qnpagename, $page, $new);
    }
    // ----------------------------------------


    print "\n================== DEBUG ====================\n\n";
    print_r($pagefmt);
    print "================== DEBUG ====================\n";
    print '</pre>';

    exit(0);

